from matplotlib import rc
rc("font", family="serif", size=12)
rc("text", usetex=True)

import daft

pgm = daft.PGM([6, 8], origin=[2,0.5])
pgm.add_node(daft.Node("animal", r"$z_1$", 5, 8))
pgm.add_node(daft.Node("domestic_animal", r"$z_2$", 4, 7))
pgm.add_node(daft.Node("carnivore", r"$z_3$", 6, 7))
pgm.add_node(daft.Node("canine", r"$z_4$", 5.5, 6.5))
pgm.add_node(daft.Node("feline", r"$z_5$", 6.5, 6.5))

dog_x = 4
dog_y = 5.5
delta = 0.6
pgm.add_node(daft.Node("dog", r"$z_6$", dog_x, dog_y ))
pgm.add_node(daft.Node("dog_f2", r"$y^2_6$", dog_x+delta, dog_y-delta,observed=True))
pgm.add_node(daft.Node("dog_f1", r"$y^1_6$", dog_x+delta, dog_y+delta,observed=True))

delta = 1.2
pgm.add_node(daft.Node("working_dog", r"$z_9$", dog_x-0.5, dog_y-delta))
pgm.add_node(daft.Node("hunting_dog", r"$z_{10}$", dog_x+0.5, dog_y-delta))

delta = 2.0
pgm.add_node(daft.Node("watch_dog", r"$z_{13}$", dog_x-1.0, dog_y-delta))
pgm.add_node(daft.Node("shepherd_dog", r"$z_{14}$", dog_x, dog_y-delta))
pgm.add_node(daft.Node("pinscher", r"$z_{16}$", dog_x-1.0, dog_y-3.0))


pgm.add_node(daft.Node("hound", r"$z_{15}$", dog_x+0.7, dog_y-delta))
pgm.add_node(daft.Node("bluetick", r"$z_{18}$", dog_x+0.7, dog_y-3.0))


x = dog_x-1.0
y = dog_y-4.0
delta = 0.6
pgm.add_node(daft.Node("doberman", r"$z_{19}$", x, y))
pgm.add_node(daft.Node("doberman_f2", r"$y^2_{19}$", x+delta, y-delta,observed=True))
#pgm.add_node(daft.Node("doberman_f1", r"$y^1_{19}$", x+delta, y+delta,observed=True))


x = dog_x
y = dog_y-3.0
delta = 0.6
pgm.add_node(daft.Node("rottweiler", r"$z_{17}$", dog_x, dog_y-3.0))
pgm.add_node(daft.Node("rottweiler_f2", r"$y^2_{17}$", x+delta, y-delta,observed=True))
#pgm.add_node(daft.Node("rottweiler_f1", r"$y^1_{17}$", x+delta, y+delta,observed=True))


fox_x = 5.5
fox_y = 5.5
delta = 0.6
pgm.add_node(daft.Node("fox", r"$z_7$", fox_x, fox_y))
#pgm.add_node(daft.Node("fox_f2", r"$y^2_7$", fox_x+delta, fox_y-delta,observed=True))
pgm.add_node(daft.Node("fox_f1", r"$y^1_7$", fox_x+delta, fox_y+delta,observed=True))

cat_x = 6.5
cat_y = 5.5
delta = 0.6
pgm.add_node(daft.Node("cat", r"$z_8$", cat_x, cat_y))
#pgm.add_node(daft.Node("cat_f2", r"$y^2_8$", cat_x+delta, cat_y-delta,observed=True))
pgm.add_node(daft.Node("cat_f1", r"$y^1_8$", cat_x+delta, cat_y+delta,observed=True))

delta = 1.2
pgm.add_node(daft.Node("domestic_cat", r"$z_{11}$", cat_x-0.5, cat_y-delta))
pgm.add_node(daft.Node("wild_cat", r"$z_{12}$", cat_x+0.5, cat_y-delta))

pgm.add_edge("domestic_animal", "animal")
pgm.add_edge("carnivore", "animal")
pgm.add_edge("canine", "carnivore")
pgm.add_edge("feline", "carnivore")
pgm.add_edge("dog", "domestic_animal")
pgm.add_edge("dog", "canine")
pgm.add_edge("fox", "canine")
pgm.add_edge("cat", "feline")


pgm.add_edge("working_dog", "dog")
pgm.add_edge("hunting_dog", "dog")

pgm.add_edge("domestic_cat", "cat")
pgm.add_edge("wild_cat", "cat")

pgm.add_edge("watch_dog", "working_dog")
pgm.add_edge("shepherd_dog", "working_dog")

pgm.add_edge("pinscher","watch_dog")
pgm.add_edge("doberman","pinscher")
pgm.add_edge("rottweiler","shepherd_dog")
pgm.add_edge("hound","hunting_dog")
pgm.add_edge("bluetick","hound")

pgm.add_edge("dog", "dog_f1")
pgm.add_edge("dog", "dog_f2")

pgm.add_edge("fox", "fox_f1")
#pgm.add_edge("fox", "fox_f2")

pgm.add_edge("cat", "cat_f1")
#pgm.add_edge("cat", "cat_f2")

#pgm.add_edge("doberman", "doberman_f1")
pgm.add_edge("doberman", "doberman_f2")

#pgm.add_edge("rottweiler", "rottweiler_f1")
pgm.add_edge("rottweiler", "rottweiler_f2")

pgm.render()
pgm.figure.savefig("pgm.pdf")
pgm.figure.savefig("pgm.png", dpi=150)